"""
Rotational Matrix Operations (:mod:`c4dynamics.rotmat`)
=======================================================

.. currentmodule:: c4dynamics.rotmat

ROTMAT
------

.. autosummary::
   :toctree: generated/

    rotx            rotation about x axis dcm by a radians 
    roty            rotation about y axis dcm by a radians 
    rotz            rotation about z axis dcm by a radians 
    dcm321          a direction cosine matrix generated by euler angels in 321 order. 
    dcm321euler     extract the euler angles from a dcm321 input 

    

Rotating Reference Frame
^^^^^^^^^^^^^^^^^^^^^^^^
A vector resolved in a given reference frame is said to be 
"expressed" in that frame (sometimes said "referred to"). 
The rate of change of a vector, as viewed by an observer fixed to and moving 
with a given reference frame, is said to be "relative to" or "with 
respect to" that reference frame. 
It's important to note here that the rate of change of a vector must be 
relative to an inertial reference frame, but it can be expressed in any reference frame. 

       

Examples
--------

For examples, see the various functions.

"""


from .rotfunc import rotx, roty, rotz, dcm321, dcm321euler 







